package com.psmreborn.nopsmdrm;

import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.provider.Settings;
import android.util.Base64;
import android.util.Log;

import javax.crypto.*;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.SecretKeySpec;
import java.security.*;
import java.security.spec.InvalidKeySpecException;
import java.util.Arrays;


public class StringEncryptor {
    private static final byte[] iv = {-126, -30, -6, -75, -99, -117, -66, 117, 39, -65, -126, -27, -12, 38, -99, 86};
    private static final byte[] salt = {-92, -102, -105, -123, 71, -33, 69, -39, -27, -32, 21, 33, 126, -81, 69, 59, 57, 29, -83, -15};

    private Context ctx;

    StringEncryptor(Context ctx){
        this.ctx = ctx;
    }

    public String getAndroidId(){
        return Settings.Secure.getString(ctx.getContentResolver(), "android_id");
    }
    public int getPsmUid() {
        try{
            ApplicationInfo psmAppInfo = this.ctx.getPackageManager().getApplicationInfo("com.playstation.psstore", 0);
            if(psmAppInfo != null) {
                return psmAppInfo.uid;
            }
        }
        catch (PackageManager.NameNotFoundException e) { };
        return 0;
    }
    private String base64(byte[] data){
        return Base64.encodeToString(data, Base64.DEFAULT);
    }

    public String encryptString(String str) {
        byte[] data = str.getBytes();
        byte[] encryptedData = encrypt(data);
        if(encryptedData != null){
            byte[] encodedData = Arrays.copyOf(encryptedData, encryptedData.length + 2);
            encodedData[encodedData.length - 2] = 1;
            encodedData[encodedData.length - 1] = 1;

            return base64(encodedData);
        }
        return null;
    }

    private byte[] encrypt(byte[] input){
        try {
            Cipher cipher = generateKeyCipher(StringEncryptor.salt, StringEncryptor.iv, Cipher.ENCRYPT_MODE);
            if (cipher != null) {
                return cipher.doFinal(input);
            }
            else {
                Log.e("STRINGENCRYPTOR", "cipher was null");
            }
        } catch (BadPaddingException | IllegalBlockSizeException e) { System.out.println(e.toString()) ;}
        return null;

    }

    private Cipher generateKeyCipher(final byte[] salt, final byte[] iv, final int opmode) {
        try {
            final String androidId = getAndroidId();
            final String psmUid = String.valueOf(getPsmUid());
            if (androidId == null || psmUid == null) {
                throw new InvalidParameterException();
            }
            final SecretKeyFactory skeyFactory = SecretKeyFactory.getInstance("PBEWITHSHAAND256BITAES-CBC-BC");
            final char[] charArray = (androidId + psmUid + "     com.playstation.psstore    ").toCharArray();
            final PBEKeySpec keySpec = new PBEKeySpec(charArray, salt, 16, 256);
            Arrays.fill(charArray, '\0');
            final SecretKeySpec key = new SecretKeySpec(skeyFactory.generateSecret(keySpec).getEncoded(), "AES");
            final Cipher newCipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            newCipher.init(opmode, key, new IvParameterSpec(iv), new SecureRandom());
            return newCipher;
        }
        catch (NoSuchPaddingException ex) {
            Log.e("STRINGENCRYPTOR", ex.toString());
            return null;
        }
        catch (InvalidAlgorithmParameterException ex2) {
            Log.e("STRINGENCRYPTOR", ex2.toString());
            return null;
        }
        catch (InvalidKeyException ex3) {
            Log.e("STRINGENCRYPTOR", ex3.toString());
            return null;
        }
        catch (InvalidKeySpecException ex4) {
            Log.e("STRINGENCRYPTOR", ex4.toString());
            return null;
        }
        catch (NoSuchAlgorithmException ex5) {
            Log.e("STRINGENCRYPTOR", ex5.toString());
            return null;
        }
    }
}
